## fltk1.3 1.3.4

=== documentation/CMakeLists.txt ===
#
# "$Id: CMakeLists.txt 10720 2015-04-25 21:42:51Z AlbrechtS $"
#
# CMakeLists.txt to build docs for the FLTK project using CMake (www.cmake.org)
#
# Copyright 1998-2015 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     http://www.fltk.org/COPYING.php
#
# Please report all bugs and problems on the following page:
#
#     http://www.fltk.org/str.php
#

set (DOCS)

#--------------------------
# build html documentation
#--------------------------

if(OPTION_BUILD_HTML_DOCUMENTATION)

    list(APPEND DOCS html)

    # generate Doxygen file "Doxyfile"

    set(GENERATE_HTML	YES)
    set(GENERATE_LATEX	NO)
    set(LATEX_HEADER	"")

    configure_file(
	${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
	${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
	@ONLY
    )

    # generate html docs

    add_custom_target(html
	# ALL
	${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating HTML documentation" VERBATIM
	DEPENDS fltk
	)

endif(OPTION_BUILD_HTML_DOCUMENTATION)

#--------------------------
# build pdf documentation
#--------------------------

if (OPTION_BUILD_PDF_DOCUMENTATION)

    list(APPEND DOCS pdf)

    # generate Doxygen file "Doxybook"

    set(GENERATE_HTML	NO)
    set(GENERATE_LATEX	YES)
    set(LATEX_HEADER	"${CMAKE_CURRENT_BINARY_DIR}/fltk-book.tex")

    configure_file(
	${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
	${CMAKE_CURRENT_BINARY_DIR}/Doxybook
	@ONLY
    )

    # generate LaTeX header fltk-book.tex

    set(FL_VERSION ${FLTK_VERSION_FULL})
    set(DOXY_VERSION ${DOXYGEN_VERSION})
    execute_process(COMMAND date +%Y
	OUTPUT_VARIABLE YEAR
	)

    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/src/fltk-book.tex.in
	${CMAKE_CURRENT_BINARY_DIR}/fltk-book.tex
	@ONLY
	)

    # generate fltk.pdf

    add_custom_command(
	OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/fltk.pdf
	COMMAND ${DOXYGEN_EXECUTABLE} Doxybook
	COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/make_pdf
	COMMAND cp -f latex/refman.pdf fltk.pdf
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	COMMENT "Generating PDF documentation" VERBATIM
	DEPENDS fltk
	)

    # add target 'pdf'

    add_custom_target(pdf
	# ALL
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/fltk.pdf
	)

endif(OPTION_BUILD_PDF_DOCUMENTATION)

#----------------------------------
# add target 'docs' for all docs
#----------------------------------

if (DOCS)

    add_custom_target(docs
	# ALL
	DEPENDS ${DOCS}
	)

endif (DOCS)

#----------------------------------
# install html + pdf documentation
#----------------------------------

if(OPTION_INSTALL_HTML_DOCUMENTATION AND OPTION_BUILD_HTML_DOCUMENTATION)

    install(DIRECTORY ${CMAKE_BINARY_DIR}/documentation/html
	DESTINATION ${FLTK_DATADIR}/doc/fltk
	)

endif(OPTION_INSTALL_HTML_DOCUMENTATION AND OPTION_BUILD_HTML_DOCUMENTATION)

if(OPTION_INSTALL_PDF_DOCUMENTATION AND OPTION_BUILD_PDF_DOCUMENTATION)

    install(FILES ${CMAKE_BINARY_DIR}/documentation/fltk.pdf
	DESTINATION ${FLTK_DATADIR}/doc/fltk/
	)

endif(OPTION_INSTALL_PDF_DOCUMENTATION AND OPTION_BUILD_PDF_DOCUMENTATION)

=== examples/Makefile ===
include Makefile.FLTK

RM    = rm -f
SHELL = /bin/sh
.SILENT:

# Executables
ALL = clipboard$(EXEEXT) \
      fltk-versions$(EXEEXT) \
      howto-add_fd-and-popen$(EXEEXT) \
      howto-browser-with-icons$(EXEEXT) \
      howto-drag-and-drop$(EXEEXT) \
      howto-parse-args$(EXEEXT) \
      howto-text-over-image-button$(EXEEXT) \
      menubar-add$(EXEEXT) \
      nativefilechooser-simple-app$(EXEEXT) \
      progress-simple$(EXEEXT) \
      shapedwindow$(EXEEXT) \
      table-as-container$(EXEEXT) \
      table-simple$(EXEEXT) \
      table-sort$(EXEEXT) \
      table-spreadsheet$(EXEEXT) \
      table-spreadsheet-with-keyboard-nav$(EXEEXT) \
      table-with-keynav$(EXEEXT) \
      tabs-simple$(EXEEXT) \
      textdisplay-with-colors$(EXEEXT) \
      texteditor-simple$(EXEEXT) \
      tree-simple$(EXEEXT) \
      tree-as-container$(EXEEXT) \
      tree-custom-draw-items$(EXEEXT) \
      tree-custom-sort$(EXEEXT) \
      tree-of-tables$(EXEEXT) \
      wizard-simple$(EXEEXT)

# default target -- build everything
default all: $(ALL)

# clean everything
clean:
	$(RM) $(ALL)
	$(RM) *.o
	$(RM) core

=== fluid/CMakeLists.txt ===
#
# "$Id: CMakeLists.txt 11816 2016-07-17 19:51:54Z greg.ercolano $"
#
# CMakeLists.txt to build fluid for the FLTK project using CMake (www.cmake.org)
#
# Copyright 1998-2016 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#     http://www.fltk.org/COPYING.php
#
# Please report all bugs and problems on the following page:
#
#     http://www.fltk.org/str.php
#

set(CPPFILES
    CodeEditor.cxx
    Fl_Function_Type.cxx
    Fl_Group_Type.cxx
    Fl_Menu_Type.cxx
    Fl_Type.cxx
    ExternalCodeEditor_UNIX.cxx
    ExternalCodeEditor_WIN32.cxx
    Fl_Widget_Type.cxx
    Fl_Window_Type.cxx
    Fluid_Image.cxx
    about_panel.cxx
    align_widget.cxx
    alignment_panel.cxx
    code.cxx
    factory.cxx
    file.cxx
    fluid.cxx
    function_panel.cxx
    template_panel.cxx
    undo.cxx
    widget_panel.cxx
)

if(APPLE AND NOT OPTION_APPLE_X11)
    set(FLUID_ICON "${CMAKE_CURRENT_SOURCE_DIR}/Fluid.app/Contents/Resources/fluid.icns")
    add_executable(fluid MACOSX_BUNDLE ${CPPFILES} "${FLUID_ICON}")
    FLTK_SET_BUNDLE_ICON(fluid "${FLUID_ICON}")
else()
    add_executable(fluid WIN32 ${CPPFILES})
endif(APPLE AND NOT OPTION_APPLE_X11)

target_link_libraries(fluid fltk fltk_images fltk_forms)

# install fluid

install(TARGETS fluid
    EXPORT FLTK-Targets
    DESTINATION ${FLTK_BINDIR}
)

# install desktop files

if(UNIX)
    install(FILES fluid.desktop
        DESTINATION ${FLTK_DATADIR}/applications
        )
    # Install mime-type file. x-fluid.desktop method is deprecated.
    install(FILES fluid.xml
        DESTINATION ${FLTK_DATADIR}/mime/packages
        )

    # Install desktop icons.
    foreach(icon 32 48 64 128)
        install(FILES icons/fluid-${icon}.png
            DESTINATION ${FLTK_DATADIR}/icons/hicolor/${icon}x${icon}/apps
            RENAME fluid.png
        )
    endforeach()
endif(UNIX)

=== fluid/Makefile ===
#
# "$Id: Makefile 11816 2016-07-17 19:51:54Z greg.ercolano $"
#
# FLUID makefile for the Fast Light Tool Kit (FLTK).
#
# Copyright 1998-2016 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#      http://www.fltk.org/COPYING.php
#
# Please report all bugs and problems on the following page:
#
#      http://www.fltk.org/str.php
#

CPPFILES = \
	CodeEditor.cxx \
	ExternalCodeEditor_UNIX.cxx \
	ExternalCodeEditor_WIN32.cxx \
	Fl_Function_Type.cxx \
	Fl_Group_Type.cxx \
	Fl_Menu_Type.cxx \
	Fl_Type.cxx \
	Fl_Widget_Type.cxx \
	Fl_Window_Type.cxx \
	Fluid_Image.cxx \
	about_panel.cxx \
	align_widget.cxx \
	alignment_panel.cxx \
	code.cxx \
	factory.cxx \
	file.cxx \
	fluid.cxx \
	function_panel.cxx \
	template_panel.cxx \
	undo.cxx \
	widget_panel.cxx

################################################################

OBJECTS = $(CPPFILES:.cxx=.o)

include ../makeinclude

all:	$(FLUID) fluid$(EXEEXT)

fluid$(EXEEXT):		$(OBJECTS) $(LIBNAME) $(FLLIBNAME) \
			$(IMGLIBNAME)
	echo Linking $@...
	$(CXX) $(ARCHFLAGS) $(CXXFLAGS) $(LDFLAGS) -o $@ $(OBJECTS) $(LINKFLTKFORMS) $(LINKFLTKIMG) $(LDLIBS)
	$(OSX_ONLY) $(INSTALL_BIN) fluid fluid.app/Contents/MacOS

fluid-shared$(EXEEXT):	$(OBJECTS) ../src/$(DSONAME) ../src/$(FLDSONAME) \
			../src/$(IMGDSONAME)
	echo Linking $@...
	$(CXX) $(ARCHFLAGS) $(CXXFLAGS) $(LDFLAGS) -o $@ $(OBJECTS) $(LINKSHARED) $(LDLIBS)

clean:
	-$(RM) *.o core.* *~ *.bck *.bak
	-$(RM) core fluid$(EXEEXT) fluid-shared$(EXEEXT)
	-$(RM) fluid.app/Contents/MacOS/fluid$(EXEEXT)

depend:	$(CPPFILES)
	makedepend -Y -I.. -f makedepend $(CPPFILES)

# Automatically generated dependencies...
include makedepend

install: all
	echo "Installing FLUID in $(DESTDIR)$(bindir)..."
	-$(INSTALL_DIR) $(DESTDIR)$(bindir)
	$(INSTALL_BIN) $(FLUID) $(DESTDIR)$(bindir)/fluid$(EXEEXT)

install-linux:
	-$(INSTALL_DIR) $(DESTDIR)/usr/share/applications
	$(INSTALL_DATA) fluid.desktop  $(DESTDIR)/usr/share/applications
	for size in 16 32 48 64 128; do \
		if test ! -d $(DESTDIR)/usr/share/icons/hicolor/$${size}x$${size}/apps; then \
			$(INSTALL_DIR) $(DESTDIR)/usr/share/icons/hicolor/$${size}x$${size}/apps; \
		fi; \
		$(INSTALL_DATA) icons/fluid-$$size.png $(DESTDIR)/usr/share/icons/hicolor/$${size}x$${size}/apps/fluid.png; \
	done
	-$(INSTALL_DIR) $(DESTDIR)/usr/share/mimelnk/application
	$(INSTALL_DATA) x-fluid.desktop  $(DESTDIR)/usr/share/mimelnk/application

install-osx:
	echo Installing Fluid in $(DESTDIR)/Applications...
	-$(INSTALL_DIR) $(DESTDIR)/Applications/fluid.app
	-$(INSTALL_DIR) $(DESTDIR)/Applications/fluid.app/Contents
	$(INSTALL_DATA) fluid.app/Contents/Info.plist $(DESTDIR)/Applications/fluid.app/Contents/Info.plist
	$(INSTALL_DATA) fluid.app/Contents/PkgInfo $(DESTDIR)/Applications/fluid.app/Contents/PkgInfo
	-$(INSTALL_DIR) $(DESTDIR)/Applications/fluid.app/Contents/MacOS
	$(RM) $(DESTDIR)/Applications/fluid.app/Contents/MacOS/fluid
	$(LN) $(bindir)/fluid $(DESTDIR)/Applications/fluid.app/Contents/MacOS/fluid
	-$(INSTALL_DIR) $(DESTDIR)/Applications/fluid.app/Contents/Resources
	$(INSTALL_DATA) fluid.app/Contents/Resources/fluid.icns $(DESTDIR)/Applications/fluid.app/Contents/Resources

uninstall:
	$(RM) $(DESTDIR)$(bindir)/fluid$(EXEEXT)

uninstall-linux:
	$(RM) $(DESTDIR)/usr/share/applications/fluid.desktop
	$(RM) $(DESTDIR)/usr/share/icons/hicolor/*/fluid.png
	$(RM) $(DESTDIR)/usr/share/mimelnk/application/x-fluid.desktop

uninstall-osx:
	$(RM) -r $(DESTDIR)/Applications/fluid.app


#
# Note: The rebuild target can only be used if you have the original .fl
#       files.  This is normally only used by the FLTK maintainers...
#

rebuild:
	./fluid -c about_panel.fl
	./fluid -c alignment_panel.fl
	./fluid -c function_panel.fl
	./fluid -c print_panel.fl
	./fluid -c template_panel.fl
	./fluid -c widget_panel.fl

#
# End of "$Id: Makefile 11816 2016-07-17 19:51:54Z greg.ercolano $".
#

=== debian/changelog ===
fltk1.3 (1.3.4-9) unstable; urgency=medium

  * d/control: Tighten B-D-I on texlive-latex-extra to definitively avoid
    #920459, which accidentally recurred in one release.  (See #921294.)

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 27 Feb 2019 21:21:30 -0500

fltk1.3 (1.3.4-8) unstable; urgency=medium

  * configure: Revert local changes in favor of using dh_autoreconf.
  * configure.ac: Use (PKG_PROG_)PKG_CONFIG per Helmut Grohne.
  * debian/*-none*: Formally renamed from debian/*-noconfig* and tweaked
    correspondingly to account for running cmake via dh_auto_configure,
    which supplies -DCMAKE_BUILD_TYPE=None.
  * debian/control:
    - Add a versioned Build-Depends-Indep entry for texlive-latex-extra to
      avoid (long)tabu lossage from #920459.  (Closes: #921294.)
    - Standards-Version: 4.3.0 (fully compliant at this point).
  * debian/rules:
    - Allow (dh_)autoreconf after all, albeit with autoheader suppressed.
    - Run cmake via dh_auto_configure per Helmut Grohne's suggestion;
      account for formal side effects of gaining -DCMAKE_BUILD_TYPE=None.
    - Use /usr/share/dpkg/{architecture,buildflags}.mk instead of calling
      dpkg-{architecture,buildflags} directly (and piecemeal).
    - Specify a host-specific pkg-config per Helmut Grohne, both in FTCONFIG
      and in the environment.  (Together with the configure.ac change,
      closes: #900190.)
    - Strip all -f*-prefix-map=* flags from fltk-config.  (See #909078.)
    - override_dh_installchangelogs: Install CHANGES as NEWS(.gz), not
      changelog(.gz).

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 26 Feb 2019 20:30:37 -0500

fltk1.3 (1.3.4-7) unstable; urgency=medium

  * debian/compat: Advance to 11.
  * debian/control:
    - Advance debhelper Build-Depends version constraint to (>= 11~).
    - Rules-Requires-Root: no (confirmed not to affect binary packages).
    - Vcs-{Browser,Git}: Move to salsa.debian.org.
    - Standards-Version: 4.1.3 (already compliant).
  * CMake/FLTKConfig.cmake.in: Never redeclare fluid, which
    FLTK-Targets.cmake already declares.  (Closes: #892979.)
  * debian/rules:
    - Address FTCBFS, based on a patch from Helmut Grohne
      for fltk1.1 (see #887636).
      + Avoid configuring during clean.
      + Do not pass build architecture compiler to cmake or configure.
      + In arch-only builds, limit coverage of test/ to the three targets we
        specifically need for fltk1.1-games.  (Many of the others involve
        trying to run freshly built fluid.)
    - Pass "/usr/bin/pkg-config freetype2" off as FTCONFIG (in lieu of
      freetype-config, which is now deprecated) (see #892341).
    - Set DEB_BUILD_MAINT_OPTIONS more readably.
    - Use ?= for DEB_HOST_(MULTI)ARCH.

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 15 Mar 2018 22:20:20 -0400

fltk1.3 (1.3.4-6) unstable; urgency=medium

  * debian/fix-fltk-targets-noconfig: Correct overzealous escaping that led
    to doubled multiarch paths for some settings.  (Closes: #871508.)

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 08 Aug 2017 14:06:54 -0400

fltk1.3 (1.3.4-5) unstable; urgency=medium

  * debian/{compat,control}: Advance to Debhelper 10.
  * debian/fix-fltk-targets-noconfig: Escape some left braces meant to be
    taken literally, for compatibility with Perl 5.26.  (Closes: #871059.)
  * debian/rules:
    - Run dh --without autoreconf.  FLTK uses a hand-maintained configh.in
      and an autoheader-unfriendly configure.ac, breaking autoreconf
      (which runs by default as of compat 10).
    - Implement nodoc support, required as of Policy 4.0.0.
  * Standards-Version: 4.0.1 (now compliant).

 -- Aaron M. Ucko <ucko@debian.org>  Sun, 06 Aug 2017 23:06:46 -0400

fltk1.3 (1.3.4-4) unstable; urgency=medium

  * debian/control: Build-depend on libxcursor-dev.  (Closes: #855863.)

 -- Aaron M. Ucko <ucko@debian.org>  Wed, 22 Feb 2017 22:28:48 -0500

fltk1.3 (1.3.4-3) unstable; urgency=medium

  * debian/fix-fltk-targets-noconfig: Append logic to refrain from
    enforcing the existence of fluid in FLTK_SKIP_FLUID mode, based
    on a suggestion from Gianfranco Costamagna <locutusofborg@d.o>.
    (Closes: #855040.)

 -- Aaron M. Ucko <ucko@debian.org>  Mon, 13 Feb 2017 22:26:35 -0500

fltk1.3 (1.3.4-2) unstable; urgency=medium

  * debian/fix-fltk-targets-noconfig: Update for current CMake output
    per Javier Serrano Polo <javier@jasp.net>.  (Closes: #852276.)
  * debian/rules: Handle interruptions better wrt fltk.spec and CMakeTmp,
    also per Javier Serrano Polo <javier@jasp.net>.  (Closes: #852279.)

 -- Aaron M. Ucko <ucko@debian.org>  Tue, 24 Jan 2017 22:22:47 -0500

fltk1.3 (1.3.4-1) unstable; urgency=medium

  * New upstream release (technically 1.3.4-1, since upstream replaced the
    original 1.3.4 release with a respin featuring improved Visual Studio
    solution files and a slightly altered version number).
  * KNOWN_BUGS.html: Comment out privacy-violating favicon link.
  * debian/control:
    - Retire explicit libfltk1.3-dbg package in favor of automatic -dbgsym
      packages.
    - Canonicalize with the help of cme fix.  In particular, declare
      Standards-Version: 3.9.8 (already compliant, not that cme checked).
  * debian/copyright: Reflect current reality.
    - HTTPS copyright-format URL.
    - Real source URL (http-only, alas).
    - Update copyright details for FLTK and (unused) convenience libraries.
  * debian/fluid.install, fluid/Makefile: /usr/share/mime/packages/fluid.xml
    has superseded /usr/share/mimelnk/application/x-fluid.desktop.
  * debian/libfltk1.3-dev.install: +/usr/include/FL/abi-version.h.
  * debian/libfltk1.3(-dev).docs: Install new documentation files:
    KNOWN_BUGS.html (and auxiliary html directory) to libfltk1.3,
    README.abi-version.txt to libfltk1.3-dev.
  * debian/libfltk1.3.symbols: Update per new release.  A few symbols changed,
    but all were private.
  * debian/rules:
    - Reflect current exported CMake configuration --


=== debian/control ===
Source: fltk1.3
Maintainer: Aaron M. Ucko <ucko@debian.org>
Section: libs
Priority: optional
Build-Depends: debhelper (>= 11~),
               libcairo2-dev,
               libgl1-mesa-dev | libgl-dev,
               libglu1-mesa-dev | libglu-dev,
               libjpeg-dev,
               libpng-dev,
               libx11-dev,
               libxcursor-dev,
               libxext-dev,
               libxft-dev,
               libxinerama-dev,
               pkg-config,
               zlib1g-dev | libz-dev
Build-Depends-Arch: cmake,
                    libasound2-dev [linux-any]
Build-Depends-Indep: doxygen-latex,
                     texlive-font-utils,
		     texlive-latex-extra (>= 2018.20190227-1~) | texlive-latex-extra (<< 2018.20181215~)
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/ucko/fltk1.3
Vcs-Git: https://salsa.debian.org/ucko/fltk1.3.git
Homepage: http://www.fltk.org/
Rules-Requires-Root: no

Package: fluid
Architecture: any
Multi-Arch: foreign
Section: devel
Depends: ${misc:Depends},
         ${shlibs:Depends}
Recommends: fltk1.3-doc,
            libfltk1.3-dev
Description: Fast Light Toolkit - user interface designer
 This package provides Fluid, an interactive GUI designer for FLTK,
 allowing graphical development of FLTK-based user
 interfaces. It natively works with (textual) .fl files, but also
 includes rough support for reading .fd files produced by fdesign (in
 libforms-bin).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk1.3-dev
Architecture: any
Section: libdevel
Depends: libfltk-cairo1.3 (= ${binary:Version}),
         libfltk-forms1.3 (= ${binary:Version}),
         libfltk-gl1.3 (= ${binary:Version}),
         libfltk-images1.3 (= ${binary:Version}),
         libfltk1.3 (= ${binary:Version}),
         libx11-dev,
         ${misc:Depends}
Recommends: fluid,
            libgl1-mesa-dev | libgl-dev,
            libglu1-mesa-dev | libglu-dev
Suggests: fltk1.3-doc,
          libcairo2-dev,
          libjpeg-dev,
          libpng-dev,
          libxext-dev,
          libxft-dev,
          libxinerama-dev,
          zlib1g-dev | libz-dev
Conflicts: libfltk-dev
Provides: libfltk-dev
Replaces: libfltk-dev
Description: Fast Light Toolkit - development files
 This package provides the files necessary for compiling programs
 that depend on FLTK.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk1.3-compat-headers
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: libfltk1.3-dev,
         ${misc:Depends}
Description: Fast Light Toolkit - compatibility header symlinks
 This package provides header symlinks with .h rather than .H extensions for
 compatibility with some older code that relies on the lowercase-h names.

Package: libfltk1.3
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - main shared library
 This package contains the files necessary for running programs
 dynamically linked with FLTK.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-cairo1.3
Architecture: any
Multi-Arch: same
Depends: libfltk1.3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - Cairo rendering layer support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's Cairo rendering layer bindings.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-forms1.3
Architecture: any
Multi-Arch: same
Depends: libfltk1.3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - Forms compatibility layer support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's Forms compatibility layer.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-gl1.3
Architecture: any
Multi-Arch: same
Depends: libfltk1.3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - OpenGL rendering support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's OpenGL rendering bindings.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-images1.3
Architecture: any
Multi-Arch: same
Depends: libfltk1.3 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Fast Light Toolkit - image loading support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's bindings to image-loading libraries.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk1.3-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: Fast Light Toolkit - documentation
 This package provides documentation for FLTK, including a chapter on
 its user interface designer (fluid).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk1.3-games
Architecture: any
Multi-Arch: foreign
Section: games
Depends: ${misc:Depends},
         ${shlibs:Depends}
Conflicts: fltk1.1-games
Replaces: fltk1.1-games
Description: Fast Light Toolkit - example games: checkers, sudoku
 This package contains the example games that accompany FLTK.
 Specifically, it contains the following two programs:
  - flblocks:   clear groups of adjacent blocks before they fill the screen;
  - flcheckers: classic board game, also known as draughts;
  - flsudoku:   Sudoku puzzle (place numbers in a grid).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

=== debian/rules ===
#!/usr/bin/make -f
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = yes
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

XCFLAGS = -Wall -Wunused -Wno-format-y2k -fPIE -fno-strict-aliasing

libdir = /usr/lib/$(DEB_HOST_MULTIARCH)
GAMES = blocks checkers sudoku
EXTRA_MFLAGS = OPTIM="$(CFLAGS) $(XCFLAGS)" STRIP=@:

PKG_CONFIG = /usr/bin/$(DEB_HOST_GNU_TYPE)-pkg-config
export PKG_CONFIG

%:
	dh $@

override_dh_autoreconf:
	-mv configure debian/configure.saved
# FLTK uses a hand-maintained configh.in and an autoheader-unfriendly
# configure.ac.
	AUTOHEADER=/bin/true dh_autoreconf

override_dh_auto_clean:
	[ -e configure ] || mv debian/configure.saved configure
	[ -e fltk.spec.saved ] || mv fltk.spec fltk.spec.saved
# Avoid reconfigure.  Removed by distclean.  >> deliberate -- keeping
# existing contents allows for proper cleaning between builds.
	echo 'RMDIR = rm -Rf' >> makeinclude
	dh_auto_clean
	mv fltk.spec.saved fltk.spec

override_dh_clean:
	rm -rf CMakeTmp
	dh_clean documentation/doxygen_sqlite3.db debian/common-build-stamp
	chmod +x debian/fix-fltk-targets-none

override_dh_auto_configure:
	[ -e fltk.spec.saved ] || mv fltk.spec fltk.spec.saved
ifneq "" "$(filter libfltk1.3-dev, $(shell dh_listpackages))"
	mkdir -p CMakeTmp
	dh_auto_configure -S cmake -B CMakeTmp -- -DOPTION_CAIRO:BOOL=ON \
	    -DOPTION_BUILD_SHARED_LIBS:BOOL=ON -DOPTION_CREATE_LINKS:BOOL=ON \
	    -DOPTION_BUILD_EXAMPLES:BOOL=OFF
	sed -e 's/ STATIC /_STATIC&/' \
	    CMakeTmp/CMakeFiles/Export/share/fltk/FLTK-Targets.cmake \
	    > CMakeTmp/etc/FLTK-Targets.cmake
	debian/fix-fltk-targets-none \
	    CMakeTmp/CMakeFiles/Export/share/fltk/FLTK-Targets-none.cmake \
	    > CMakeTmp/etc/FLTK-Targets-none.cmake
endif
	dh_auto_configure -- FTCONFIG="$(PKG_CONFIG) freetype2" \
            DSOFLAGS="$(filter-out -fPIE -pie,$(LDFLAGS))" \
	    --enable-shared --enable-cairo --enable-cp936 --with-links \
	    --with-optim=$(filter -O%,$(CXXFLAGS)) --libdir=$(libdir)
	mv fltk.spec.saved fltk.spec

override_dh_auto_build-arch:
	dh_auto_build -- $(EXTRA_MFLAGS) DIRS='$$(IMAGEDIRS) src cairo fluid'
	$(MAKE) -C test $(EXTRA_MFLAGS) $(GAMES)

override_dh_auto_build-indep:
ifneq "" "$(filter nodoc,$(DEB_BUILD_OPTIONS))"
	dh_auto_build -- $(EXTRA_MFLAGS) \
	    DIRS='$$(IMAGEDIRS) src cairo fluid test'
else
	dh_auto_build -- $(EXTRA_MFLAGS)
	$(MAKE) -C documentation html pdf
endif

override_dh_auto_install-arch:
	dh_auto_install -a -- DIRS='$$(IMAGEDIRS) src cairo fluid'
	mkdir -p debian/tmp/usr/games
	mkdir -p debian/tmp/usr/lib/fltk
	mkdir -p debian/tmp/usr/share/applications
	mkdir -p debian/tmp/usr/share/icons/hicolor/32x32/apps
	mkdir -p debian/tmp/usr/share/icons/hicolor/128x128/apps
	mkdir -p debian/tmp/usr/share/man/man6
	mkdir -p debian/tmp/usr/share/pixmaps
## fltk1.3-games (installed by hand to be able to add fl prefixes.)
	for game in $(GAMES); do \
	    cp test/$$game debian/tmp/usr/games/fl$$game && \
	    sed -e 's,Exec=,&/usr/games/fl,; s,Icon=,&fl,; s,Name=,&FLTK ,' \
	      test/desktop/$$game.desktop \
	      >debian/tmp/usr/share/applications/fl$$game.desktop && \
	    cp test/desktop/$$game-32.png \
	      debian/tmp/usr/share/icons/hicolor/32x32/apps/fl$$game.png && \
	    cp test/desktop/$$game-128.png \
	      debian/tmp/usr/share/icons/hicolor/128x128/apps/fl$$game.png && \
	    sed -e '1s,^\.TH ,&fl,; 3s,^,fl,' documentation/src/$$game.man \
	      >debian/tmp/usr/share/man/man6/fl$$game.6 \
	    || exit 1; \
	done
## fluid
	$(MAKE) -C fluid install-linux DESTDIR=$(CURDIR)/debian/tmp
## libfltk1.3-dev
	cp debian/CMakeCache.txt CMakeTmp/etc/*.cmake \
	    CMake/FLTK-Functions.cmake debian/tmp/usr/lib/fltk
	sed -e 's/ -f[a-z]*-prefix-map=[^ ]*//' fltk-config \
	    > debian/tmp/usr/bin/fltk-config
	chmod +x debian/tmp/usr/bin/fltk-config

ifeq "" "$(filter nodoc,$(DEB_BUILD_OPTIONS))"
  override_dh_auto_install-indep:
	dh_auto_install -i -- DIRS='documentation test'
	mkdir -p debian/tmp/usr/share/doc/fltk1.3-doc
	cp documentation/latex/refman.pdf \
	    debian/tmp/usr/share/doc/fltk1.3-doc/fltk.pdf
endif

override_dh_install-arch:
## libfltk1.3-dev
	sed -e 's/ -f[a-z]*-prefix-map=[^ ]*//' fltk-config \
	    > debian/tmp/usr/bin/fltk-config
	chmod +x debian/tmp/usr/bin/fltk-config
	dh_install

override_dh_installdocs:
	dh_installdocs -A CREDITS README

override_dh_makeshlibs:
	dh_makeshlibs  -V

override_dh_installchangelogs:
	dh_installchangelogs
	for x in debian/*/usr/share/doc/*/changelog; do \
	    mv -v $$x `dirname $$x`/NEWS; \
	done
